"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const TSTypeAliasDeclaration_1 = require("./visitors/TSTypeAliasDeclaration");
const ArrowFunctionExpression_1 = require("./visitors/ArrowFunctionExpression");
const TSTypeAnnotation_1 = require("./visitors/TSTypeAnnotation");
const TSAsExpression_1 = require("./visitors/TSAsExpression");
const NewExpression_1 = require("./visitors/NewExpression");
const CallExpression_1 = require("./visitors/CallExpression");
const TSTypeParameterDeclaration_1 = require("./visitors/TSTypeParameterDeclaration");
const TSInterfaceDeclaration_1 = require("./visitors/TSInterfaceDeclaration");
const TSDeclareFunction_1 = require("./visitors/TSDeclareFunction");
const ClassDeclaration_1 = require("./visitors/ClassDeclaration");
const ExportDefaultDeclaration_1 = require("./visitors/ExportDefaultDeclaration");
const ExportNamedDeclaration_1 = require("./visitors/ExportNamedDeclaration");
const VariableDeclaration_1 = require("./visitors/VariableDeclaration");
const Program_1 = require("./visitors/Program");
const visitor = {
    TSTypeAliasDeclaration: TSTypeAliasDeclaration_1.TSTypeAliasDeclaration,
    ArrowFunctionExpression: ArrowFunctionExpression_1.ArrowFunctionExpression,
    TSTypeAnnotation: TSTypeAnnotation_1.TSTypeAnnotation,
    TSAsExpression: TSAsExpression_1.TSAsExpression,
    NewExpression: NewExpression_1.NewExpression,
    CallExpression: CallExpression_1.CallExpression,
    TSTypeParameterDeclaration: TSTypeParameterDeclaration_1.TSTypeParameterDeclaration,
    TSInterfaceDeclaration: TSInterfaceDeclaration_1.TSInterfaceDeclaration,
    TSDeclareFunction: TSDeclareFunction_1.TSDeclareFunction,
    ClassDeclaration: ClassDeclaration_1.ClassDeclaration,
    ExportDefaultDeclaration: ExportDefaultDeclaration_1.ExportDefaultDeclaration,
    ExportNamedDeclaration: ExportNamedDeclaration_1.ExportNamedDeclaration,
    VariableDeclaration: VariableDeclaration_1.VariableDeclaration,
    Program: Program_1.Program,
};
exports.default = (_babel, opts = {}) => {
    if (typeof opts.isJSX === 'undefined') {
        opts.isJSX = true;
    }
    if (typeof opts.isAmbientContext === 'undefined') {
        opts.isAmbientContext = false;
    }
    return {
        name: 'babel-plugin-typescript-to-flow',
        visitor,
        manipulateOptions(_babel, parserOpts) {
            parserOpts.plugins.push('typescript');
            if (opts.isJSX) {
                parserOpts.plugins.push('jsx');
            }
            parserOpts.plugins.push('classProperties');
            parserOpts.plugins.push('objectRestSpread');
            parserOpts.plugins.push('optionalChaining');
            parserOpts.plugins.push('nullishCoalescingOperator');
            parserOpts.plugins.push('dynamicImport');
        },
    };
};
//# sourceMappingURL=index.js.map