"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Program = void 0;
const t = __importStar(require("@babel/types"));
const replaceWith_1 = require("../utils/replaceWith");
const convertTSTypeAliasDeclaration_1 = require("../converters/convertTSTypeAliasDeclaration");
const transformClassDeclaration_1 = require("../transforms/transformClassDeclaration");
const convertTSInterfaceDeclaration_1 = require("../converters/convertTSInterfaceDeclaration");
const convertTSDeclareFunction_1 = require("../converters/convertTSDeclareFunction");
const helperTypes_1 = __importDefault(require("../helperTypes"));
exports.Program = {
    enter(path, state) {
        const isAmbientContext = state.opts.isAmbientContext;
        for (const st of path.get('body')) {
            const node = st.node;
            // todo: isTSTypeAliasDeclaration on NodePath
            if (t.isTSTypeAliasDeclaration(node)) {
                const replacement = convertTSTypeAliasDeclaration_1.convertTSTypeAliasDeclaration(node, isAmbientContext);
                replaceWith_1.replaceWith(st, replacement);
            }
            // todo: isClassDeclaration on NodePath
            if (t.isClassDeclaration(node)) {
                transformClassDeclaration_1.transformClassDeclaration(st, isAmbientContext);
            }
            // todo: isTSInterfaceDeclaration on NodePath
            if (t.isTSInterfaceDeclaration(node)) {
                replaceWith_1.replaceWith(st, convertTSInterfaceDeclaration_1.convertTSInterfaceDeclaration(node, isAmbientContext));
            }
            if (t.isTSDeclareFunction(node)) {
                if (!isAmbientContext && !node.declare) {
                    throw path.buildCodeFrameError('unexpected TSDeclareFunction');
                }
                const replacement = convertTSDeclareFunction_1.convertTSDeclareFunction(node);
                replaceWith_1.replaceWith(st, replacement);
            }
        }
    },
    exit(path, state) {
        const usedHelperTypes = new Set();
        path.traverse({
            GenericTypeAnnotation(annotationNodePath) {
                const node = annotationNodePath.node;
                if (t.isIdentifier(node.id)) {
                    const name = node.id.name;
                    // @ts-expect-error
                    if (helperTypes_1.default[name]) {
                        usedHelperTypes.add(name);
                    }
                }
            },
        });
        const body = path.get('body');
        const imports = body.filter(st => st.isImportDeclaration());
        let after;
        if (imports.length > 0) {
            after = imports[imports.length - 1];
        }
        usedHelperTypes.forEach(helperName => {
            if (after)
                after.insertAfter(helperTypes_1.default[helperName]);
            else
                body[0].insertBefore(helperTypes_1.default[helperName]);
        });
    },
};
//# sourceMappingURL=Program.js.map